<?xml version='1.0'?>
<xsl:stylesheet version="1.0"
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:msxsl="urn:schemas-microsoft-com:xslt">

<xsl:output method="html"/>

<xsl:template match="/Menu">
		<h1>XML On-Demand Menu Loading</h1>
		<ul><xsl:apply-templates select="MenuItem"/></ul>
</xsl:template>

<xsl:template match="MenuItem">
	<xsl:variable name="open" select="@expanded='true'"/>
	<xsl:variable name="childrenUnloaded" select="@childItemsURL"/>
	<xsl:variable name="children" select="count(./MenuItem)>0 or $childrenUnloaded"/>
	<xsl:variable name="noURL" select="not(@url)"/>
	<li class="child">
		<xsl:attribute name="childID">menu<xsl:value-of select="@id"/></xsl:attribute>
		<xsl:if test="$children">
			<xsl:attribute name="class">parent</xsl:attribute>
			<img height="9" width="9">
				<xsl:attribute name="onclick"><xsl:if test="$childrenUnloaded">LoadChildren(this)</xsl:if><xsl:if test="not($childrenUnloaded)">ToggleMenu(this)</xsl:if></xsl:attribute>
				<xsl:attribute name="childID">menu<xsl:value-of select="@id"/></xsl:attribute>
				<xsl:attribute name="id">arrow<xsl:value-of select="@id"/></xsl:attribute>
				<xsl:attribute name="src">
					<xsl:if test="$open">open.gif</xsl:if>
					<xsl:if test="not($open)">closed.gif</xsl:if>
				</xsl:attribute>
			</img>
		</xsl:if>
		<a>
			<xsl:if test="not($noURL)"><xsl:attribute name="href"><xsl:value-of select="@url"/></xsl:attribute></xsl:if>
			<xsl:if test="$children"><xsl:attribute name="onclick"><xsl:if test="$childrenUnloaded">LoadChildren(this)</xsl:if><xsl:if test="not($childrenUnloaded)">ToggleMenu(this)</xsl:if></xsl:attribute></xsl:if>
			<xsl:attribute name="title"><xsl:value-of select="@description"/></xsl:attribute>
			<xsl:value-of select="@title"/>
		</a>
		<xsl:if test="$children and not($childrenUnloaded)">
			<ul>
				<xsl:if test="not($open)"><xsl:attribute name="style">display:none</xsl:attribute></xsl:if>
				<xsl:attribute name="id">menu<xsl:value-of select="@id"/></xsl:attribute>
				<xsl:apply-templates select="MenuItem"/>
			</ul>
		</xsl:if>
	</li>
</xsl:template>

</xsl:stylesheet>
