<?xml version='1.0'?>
<xsl:stylesheet version="1.0"
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:msxsl="urn:schemas-microsoft-com:xslt">

<xsl:output method="html"/>

<xsl:template match="/Menu">
	<html>
		<head>
			<title>XML Menu Full Listing</title>
			<style type="text/css">
				h1	{ font-family:Arial; font-size:120%; border-bottom:1px solid #cccccc; margin-bottom:0px }
				ul	{ margin-top:0px }
				li.children	{ cursor:hand }
				li.loner	{ color:#66cc66; cursor:auto }
			</style>
			<script type="text/javascript">
				function ToggleMenu(m){
					var submenu = document.getElementById(m.getAttribute("childItems"));
					if (!submenu) return;
					submenu.style.display = submenu.style.display=='none'?'':'none';
					event.cancelBubble=true;
				}
			</script>
		</head>
		<body>
			<h1>XML Menu Full Listing</h1>
			<ul><xsl:apply-templates select="MenuItem"/></ul>
		</body>
	</html>
</xsl:template>

<xsl:template match="MenuItem">
	<li>
		<xsl:attribute name="childItems">menu<xsl:value-of select="@id"/></xsl:attribute>
		<xsl:attribute name="title"><xsl:value-of select="@description"/></xsl:attribute>
		<xsl:choose>
			<xsl:when test="count(./MenuItem)=0">
				<xsl:attribute name="class">loner</xsl:attribute>
				<xsl:attribute name="onclick">event.cancelBubble=true</xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="class">children</xsl:attribute>
				<xsl:attribute name="onclick">ToggleMenu(this)</xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:value-of select="@title"/>
		<xsl:if test="count(./MenuItem)>0">
			<ul>
				<xsl:if test="not(@expanded) or @expanded!='true'"><xsl:attribute name="style">display:none</xsl:attribute></xsl:if>
				<xsl:attribute name="id">menu<xsl:value-of select="@id"/></xsl:attribute>
				<xsl:apply-templates select="MenuItem"/>
			</ul>
		</xsl:if>
	</li>
</xsl:template>

</xsl:stylesheet>
